commit 268c6633dabdcf27f7146b33bead3532a71c27a4
Author: jklowden <jklowden>
Date:   Tue Jan 12 15:43:17 2010 +0000

    Win32 support: Added getopt.c from NetBSD and made tsql  compile without warnings

diff --git a/ChangeLog b/ChangeLog
index 86f1486..686adbe 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Tue Jan 12 10:38:18 EST 2010	JK Lowden <jklowden@freetds.org>
+	* Makefile.am src/apps/tsql.c src/replacements/getopt.c
+	* win32/config.h
+	- Win32 support: Added getopt.c from NetBSD and made tsql 
+	- compile without warnings
+
 Tue Jan 12 11:20:04 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/replacements/strtok_r.c: Fix strtok_r function
 
@@ -2121,4 +2127,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2939 2010/01/12 10:20:41 freddy77 Exp $
+$Id: ChangeLog,v 1.2940 2010/01/12 15:43:17 jklowden Exp $
diff --git a/Makefile.am b/Makefile.am
index 516be66..cb83226 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1,4 +1,4 @@
-# version $Id: Makefile.am,v 1.45 2008/11/12 20:58:45 freddy77 Exp $
+# version $Id: Makefile.am,v 1.46 2010/01/12 15:43:17 jklowden Exp $
 
 ## SUBDIRS determines in which directories automake will generate a Makefile
 ## See also AC_OUTPUT in configure.ac
@@ -18,7 +18,7 @@ VMS	=	vms/config_h.vms \
 EXTRA_DIST = 	$(VMS) interfaces PWD.in BUGS \
 		freetds.conf locales.conf \
 		autogen.sh freetds.spec.in freetds.spec tds.dox \
-		config.rpath
+		config.rpath Nmakefile
 
 
 ETC	=	$(DESTDIR)$(sysconfdir)
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index 309879c..a1d716b 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -59,7 +59,9 @@
 #endif /* HAVE_STRING_H */
 
 #if HAVE_UNISTD_H
-#include <unistd.h>
+# include <unistd.h>
+#elif defined(_WIN32)
+# include <io.h>
 #endif /* HAVE_UNISTD_H */
 
 /* HP-UX require some constants defined by limits.h */
@@ -85,7 +87,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.131 2010/01/08 22:08:01 jklowden Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.132 2010/01/12 15:43:17 jklowden Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -115,7 +117,7 @@ static void tsql_print_usage(const char *progname);
 static int get_opt_flags(char *s, int *opt_flags);
 static void populate_login(TDSLOGIN * login, int argc, char **argv);
 static int tsql_handle_message(const TDSCONTEXT * context, TDSSOCKET * tds, TDSMESSAGE * msg);
-static void slurp_input_file(char *fname, char **mybuf, int *bufsz, size_t *buflen, int *line);
+static void slurp_input_file(char *fname, char **mybuf, size_t *bufsz, size_t *buflen, int *line);
 
 static char *
 tsql_readline(char *prompt)
@@ -138,7 +140,7 @@ tsql_readline(char *prompt)
 		printf("%s", prompt);
 	for (;;) {
 		/* read a piece */
-		if (fgets(line + pos, sz - pos, stdin) == NULL) {
+		if (fgets(line + pos, (int)(sz - pos), stdin) == NULL) {
 			if (pos)
 				return line;
 			break;
@@ -624,7 +626,7 @@ tsql_handle_message(const TDSCONTEXT * context, TDSSOCKET * tds, TDSMESSAGE * ms
 }
 
 static void
-slurp_input_file(char *fname, char **mybuf, int *bufsz, size_t *buflen, int *line)
+slurp_input_file(char *fname, char **mybuf, size_t *bufsz, size_t *buflen, int *line)
 {
 	FILE *fp = NULL;
 	register char *n;
@@ -668,7 +670,7 @@ main(int argc, char **argv)
 	char prompt[20];
 	int line = 0;
 	char *mybuf;
-	int bufsz = 4096;
+	size_t bufsz = 4096;
 	size_t buflen = 0;
 	TDSSOCKET *tds;
 	TDSLOGIN *login;
diff --git a/src/replacements/getopt.c b/src/replacements/getopt.c
new file mode 100644
index 0000000..3a51ef6
--- /dev/null
+++ b/src/replacements/getopt.c
@@ -0,0 +1,164 @@
+/*	$NetBSD: getopt.c,v 1.27 2005/11/29 03:12:00 christos Exp $	*/
+
+/*
+ * Copyright (c) 1987, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#undef LIBC_SCCS
+
+#if !defined(_WIN32)
+# include <sys/cdefs.h>
+#else
+# define __UNCONST(x) ((char*)(x)) 
+# define getprogname() (nargv[0])
+# define _DIAGASSERT(x) assert((x))
+#endif
+
+#ifdef _FREETDS_LIBRARY_SOURCE
+# include "tds_sysdep_private.h"
+#endif /* _FREETDS_LIBRARY_SOURCE */
+
+#if defined(LIBC_SCCS) && !defined(lint)
+# if 0
+  static char sccsid[] = "@(#)getopt.c	8.3 (Berkeley) 4/27/95";
+# else
+  __RCSID("$NetBSD: getopt.c,v 1.27 2005/11/29 03:12:00 christos Exp $");
+# endif
+#else 
+ TDS_RCSID(var, "$Id: getopt.c,v 1.1 2010/01/12 15:43:17 jklowden Exp $");
+#endif /* LIBC_SCCS and not lint */
+
+#if !defined(_WIN32)
+# include "namespace.h"
+#endif
+
+#include <assert.h>
+#include <errno.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#if !defined(_WIN32)
+# include <unistd.h>
+#endif
+
+#ifdef __weak_alias
+__weak_alias(getopt,_getopt)
+#endif
+
+int	opterr = 1,		/* if error message should be printed */
+	optind = 1,		/* index into parent argv vector */
+	optopt,			/* character checked for validity */
+	optreset;		/* reset getopt */
+char	*optarg;		/* argument associated with option */
+
+#define	BADCH	(int)'?'
+#define	BADARG	(int)':'
+#define	EMSG	""
+
+/*
+ * getopt --
+ *	Parse argc/argv argument vector.
+ */
+int
+getopt(nargc, nargv, ostr)
+	int nargc;
+	char * const nargv[];
+	const char *ostr;
+{
+	static const char *place = EMSG;	/* option letter processing */
+	char *oli;				/* option letter list index */
+
+	_DIAGASSERT(nargv != NULL);
+	_DIAGASSERT(ostr != NULL);
+
+	if (optreset || *place == 0) {		/* update scanning pointer */
+		optreset = 0;
+		place = nargv[optind];
+		if (optind >= nargc || *place++ != '-') {
+			/* Argument is absent or is not an option */
+			place = EMSG;
+			return (-1);
+		}
+		optopt = *place++;
+		if (optopt == '-' && *place == 0) {
+			/* "--" => end of options */
+			++optind;
+			place = EMSG;
+			return (-1);
+		}
+		if (optopt == 0) {
+			/* Solitary '-', treat as a '-' option
+			   if the program (eg su) is looking for it. */
+			place = EMSG;
+			if (strchr(ostr, '-') == NULL)
+				return -1;
+			optopt = '-';
+		}
+	} else
+		optopt = *place++;
+
+	/* See if option letter is one the caller wanted... */
+	if (optopt == ':' || (oli = strchr(ostr, optopt)) == NULL) {
+		if (*place == 0)
+			++optind;
+		if (opterr && *ostr != ':')
+			(void)fprintf(stderr,
+			    "%s: unknown option -- %c\n", getprogname(),
+			    optopt);
+		return (BADCH);
+	}
+
+	/* Does this option need an argument? */
+	if (oli[1] != ':') {
+		/* don't need argument */
+		optarg = NULL;
+		if (*place == 0)
+			++optind;
+	} else {
+		/* Option-argument is either the rest of this argument or the
+		   entire next argument. */
+		if (*place)
+			optarg = __UNCONST(place);
+		else if (nargc > ++optind)
+			optarg = nargv[optind];
+		else {
+			/* option-argument absent */
+			place = EMSG;
+			if (*ostr == ':')
+				return (BADARG);
+			if (opterr)
+				(void)fprintf(stderr,
+				    "%s: option requires an argument -- %c\n",
+				    getprogname(), optopt);
+			return (BADCH);
+		}
+		place = EMSG;
+		++optind;
+	}
+	return (optopt);			/* return option letter */
+}
diff --git a/win32/config.h b/win32/config.h
index 34ade6a..46dfe26 100644
--- a/win32/config.h
+++ b/win32/config.h
@@ -246,4 +246,4 @@
 
 typedef SSIZE_T ssize_t;
 
-
+#define HAVE_LOCALE_H 1

